variables:
  KICS_IMAGE: "registry.gitlab.com/ezbrew/vger/docker-images/kics/releases/kics-1.6.12:latest"
  TERRAFORM_IMAGE: "registry.gitlab.com/ezbrew/vger/docker-images/terraform-docker/releases/terraform-1.3:latest"
  BUILD_UTILITY_IMAGE: "registry.gitlab.com/ezbrew/vger/docker-images/build-utility-docker/releases/build-utility:latest"

  TF_IN_AUTOMATION: "true"

include:
  - project: "ezbrew/vger/ci-templates/ci-compliance"
    ref: main
    file:
      - "compliance-ci-common.yml"
  - project: "ezbrew/vger/ci-templates/ci-terraform"
    ref: BREW-0001
    file:
      - "terraform-base-ci.yml"

stages:
  - kics-scan
  - format
  - validate
  - init
  - plan
  - apply
  - destroy

kics terraform scan:
  image: $KICS_IMAGE
  variables:
    KICS_SCAN_PATH: $TF_ROOT
  extends:
    - .kics-scan
  rules:
    - if: $CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH != null

terraform-fmt:
  extends: .terraform-fmt
  allow_failure: true
  rules:
    - if: $CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH != null

terraform-fmt-no-fail:
  extends: .terraform-fmt-no-fail
  allow_failure: true
  rules:
    - if: $CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH != null

terraform-validate:
  extends:
    - .terraform-workspaces
    - .terraform-validate
  rules:
    - if: $CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH != null

terraform-init:
  extends:
    - .terraform-workspaces
    - .terraform-init
  rules:
    - if: $CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH != null

terraform-plan:
  extends:
    - .terraform-workspaces
    - .terraform-plan
  rules:
    - if: $CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH != null

terraform-apply:
  extends:
    - .terraform-workspaces
    - .terraform-apply
  needs: [terraform-plan]
  rules:
    - if: $CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH != null

terraform-destroy:
  extends:
    - .terraform-workspaces
    - .terraform-destroy
  needs: [terraform-plan]
  when: manual
  rules:
    - if: $CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH != null
